## xdmf 3.0+git20190531

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)

project(Xdmf)


if(WIN32)
  ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_DEPRECATE)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(XDMF_LIBNAME "Xdmf" CACHE STRING "Name for this xdmf library to avoid collision")

set(XDMF_MAJOR_VERSION 3)
set(XDMF_MINOR_VERSION 0)
set(XDMF_PATCH_VERSION 0)
set(XDMF_VERSION "${XDMF_MAJOR_VERSION}.${XDMF_MINOR_VERSION}.${XDMF_PATCH_VERSION}")

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")

if(BUILD_SHARED_LIBS)
  set(BUILD_SHARED 1)
endif()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/XdmfConfig.hpp.in
               ${CMAKE_CURRENT_BINARY_DIR}/XdmfConfig.hpp)

# Enable CMake testing
option(XDMF_BUILD_TESTING "Build Tests" OFF)
if(XDMF_BUILD_TESTING)
  enable_testing()
  include(CTest)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
list(APPEND CMAKE_MODULE_PATH
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/VersionSuite)
if(XDMF_BUILD_TESTING)
  list(APPEND CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}/CMake/TestingSuite)
endif()

include(XdmfFunctions)

# Should we build with documentation
option(XDMF_BUILD_DOCUMENTATION OFF)
if(XDMF_BUILD_DOCUMENTATION)
  add_subdirectory(doc)
endif()

# Wrapper Setup
option(XDMF_WRAP_PYTHON OFF)
option(XDMF_WRAP_JAVA OFF)

#check for TIFF
find_package(TIFF)
if (TIFF_FOUND)
  add_definitions(-DXDMF_BUILD_TIFF)
  include_directories(${TIFF_INCLUDE_DIR})
endif (TIFF_FOUND)

# Test for DSM
option(XDMF_BUILD_DSM OFF)
mark_as_advanced(XDMF_BUILD_DSM)
if(XDMF_BUILD_DSM)
  find_package(MPI REQUIRED)
  if(MPI_FOUND)
    include_directories(${MPI_INCLUDE_PATH})
    # The Intel compiler requires an extra tag for CXX_FLAGS in order to properly build.
    if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
      add_definitions(-DMPICH_IGNORE_CXX_SEEK)
    endif ()
  endif()
  option(XDMF_BUILD_DSM_THREADS ON)
  if (XDMF_WRAP_PYTHON)
    find_path(PYTHON_INCLUDE_MPI4PY_DIR
      NAMES mpi4py/mpi4py.i
      DOC   "Directory containing the mpi4py/mpi4py.i file")
  endif ()
  add_definitions(-DXDMF_BUILD_DSM)
endif()

# If we are wrapping either, we need swig
if(XDMF_WRAP_PYTHON OR XDMF_WRAP_JAVA)
  find_package(SWIG 2.0.0 REQUIRED)
  include(${SWIG_USE_FILE})
endif()

# If we are wrapping python, let's include it in the top level
if(XDMF_WRAP_PYTHON)
  find_package(PythonInterp ${REQUESTED_PYTHON_VERSION} REQUIRED)
  find_package(PythonLibs ${REQUESTED_PYTHON_VERSION} REQUIRED)
  if (XDMF_BUILD_DSM)
    find_package (MPI4PY REQUIRED)
    if (MPI4PY_FOUND)
      if ("${PYTHON_INCLUDE_MPI4PY_DIR}" STREQUAL "")
        set(PYTHON_INCLUDE_MPI4PY_DIR ${MPI4PY_INCLUDE_DIR})
      endif ()
    endif ()
    include_directories(${PYTHON_INCLUDE_DIRS} ${MPI_CXX_INCLUDE_PATH} ${PYTHON_INCLUDE_MPI4PY_DIR})
  else ()
    include_directories(${PYTHON_INCLUDE_DIRS})
  endif ()

  # A macro to swig and create the python files
  # Since we essentually do the same thing inside and outside core, it
  # would be easier as a macro
  # Parameters:
  #     python_name = the name of the intended target to be wrapped
  #     ${ARGN} = any dependencies needed by the target
  # Output:
  #     Target Name = the output target name will have ${python_name} as its name
  macro(XDMF_SWIG_PYTHON python_name)
    set(CMAKE_SWIG_OUTDIR ${CMAKE_BINARY_DIR})
    # optimize swig generation --- these are all flags corresponding to -O
    # except -fvirtual which breaks visitor operation
    set(CMAKE_SWIG_FLAGS ${XDMF_SWIG_FLAGS} -modern -fastdispatch -nosafecstrings -noproxydel -fastproxy -fastinit -fastunpack -fastquery -modernargs -nobuildnone)
    #Enables DSM
    if (XDMF_BUILD_DSM)
      set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DXDMF_BUILD_DSM)
      if (XDMF_BUILD_DSM_THREADS)
        set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DXDMF_BUILD_DSM_THREADS)
      endif ()
    endif ()
    if (TIFF_FOUND)
      set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DXDMF_BUILD_TIFF)
    endif ()
    set_source_files_properties(${python_name}.i PROPERTIES CPLUSPLUS ON)
    set(swig_extra_generated_files "")
    swig_add_module(${python_name}Python python ${python_name}.i)

    if (NOT APPLE)
      swig_link_libraries(${python_name}Python ${python_name} ${PYTHON_LIBRARIES})
    else ()
      swig_link_libraries(${python_name}Python ${python_name})
    endif ()

    set_property(DIRECTORY APPEND PROPERTY
      ADDITIONAL_MAKE_CLEAN_FILES
      ${CMAKE_CURRENT_BINARY_DIR}/${python_name}.pyc
    )

    if("${ARGN}" STRGREATER "")
      add_dependencies(${python_name} "${ARGN}")
    endif()

    if(APPLE)
      set_target_properties(${SWIG_MODULE_${python_name}Python_REAL_NAME}
        PROPERTIES
        LINK_FLAGS "-undefined dynamic_lookup")
    endif()

    set_target_properties(${SWIG_MODULE_${python_name}Python_REAL_NAME}
      PROPERTIES
      OUTPUT_NAME "_${python_name}")

    set(
      PYTHON_INSTALL_DIR
      ${CMAKE_INSTALL_PREFIX}/lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/xdmf
      )

    string(TOUPPER ${python_name} python_name_upper)
    set(${python_name_upper}_PYTHON
      ${PYTHON_INSTALL_DIR}/${python_name}.py)
    get_directory_property(${python_name}Parent PARENT_DIRECTORY)
    if(NOT "${${python_name}Parent}" STREQUAL "")
      set(${python_name_upper}_PYTHON ${${python_name_upper}_PYTHON}
        PARENT_SCOPE)
    endif()

    install(FILES ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${python_name}.py
      DESTINATION ${PYTHON_INSTALL_DIR})
    install(TARGETS ${SWIG_MODULE_${python_name}Python_REAL_NAME}
      DESTINATION ${PYTHON_INSTALL_DIR})
  endmacro()
endif()

# If we are wrapping java, let's include it in the top level
if(XDMF_WRAP_JAVA)
  find_package(Java REQUIRED)
  find_package(JNI REQUIRED)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}
    ${JAVA_INCLUDE_PATH}
    ${JAVA_INCLUDE_PATH2})

  # A macro to swig and create the jar files
  # Since we essentually do the same thing inside and outside core, it
  # would be easier as a macro
  # Parameters:
  #     java_name = the name of the intended target to be wrapped
  #     ${ARGN} = any dependencies needed by the target
  # Output:
  #     Target Name     = the output target name will have ${java_name}Java as its name
  #     Target Jar      = the output target jar will have ${java_name}Java.jar as its name
  macro(XDMF_SWIG_JAVA java_name)
    set(${java_name}_JAVA_JAR ${CMAKE_BINARY_DIR}/${java_name}.jar)
    set(XDMF_JAVA_PACKAGE_DIR mil/army/arl/xdmf)
    set(XDMF_JAVA_DIR ${CMAKE_BINARY_DIR}/${XDMF_JAVA_PACKAGE_DIR})
    set(CMAKE_SWIG_OUTDIR ${XDMF_JAVA_DIR})
    set(CMAKE_SWIG_FLAGS ${XDMF_SWIG_FLAGS} -v -make_default -package mil.army.arl.xdmf)
    set_source_files_properties(${java_name}.i PROPERTIES CPLUSPLUS ON)
    set(swig_extra_generated_files "")
    swig_add_module(${java_name}Java java ${java_name}.i)
    swig_link_libraries(${java_name}Java ${java_name})

    if(WIN32)
      set(java_files *.java)
      set(java_dest "bin")
      set(separator "\;")
    else()
      set(java_files ${XDMF_JAVA_DIR}/*.java)
      set(java_dest "lib/java")
      set(separator ":")
    endif()

    add_custom_target(${java_name}_Java_Dir ALL DEPENDS ${XDMF_JAVA_DIR})
    add_custom_command(OUTPUT ${XDMF_JAVA_DIR}
      COMMAND ${CMAKE_COMMAND} -E make_directory ${XDMF_JAVA_DIR})
    add_custom_target(Compiled_${java_name}_Jar ALL DEPENDS
      ${${java_name}_JAVA_JAR})
    add_custom_command(OUTPUT ${${java_name}_JAVA_JAR}
      COMMAND ${CMAKE_COMMAND} -E chdir ${XDMF_JAVA_PACKAGE_DIR}
              ${JAVA_COMPILE} -cp \".${java_cp_jars}\" ${java_files}
      COMMAND ${JAVA_ARCHIVE} -cvf ${${java_name}_JAVA_JAR}
             "${XDMF_JAVA_PACKAGE_DIR}/*.class")
    add_dependencies(${java_name}Java ${java_name}_Java_Dir)
    add_dependencies(Compiled_${java_name}_Jar ${java_name}Java)

    if(NOT ${ARGN} EQUAL "")
      add_dependencies(Compiled_${java_name}_Jar "${ARGN}")
    endif()

    set_property(DIRECTORY APPEND PROPERTY
      ADDITIONAL_MAKE_CLEAN_FILES
      ${CMAKE_CURRENT_BINARY_DIR}/${java_name}.jar
      ${XDMF_JAVA_DIR})

    set(java_cp_jars "${java_cp_jars}${separator}${${java_name}_JAVA_JAR}")
    string(TOUPPER ${java_name} java_name_upper)
    set(${java_name_upper}_JAVA_JAR
      ${CMAKE_INSTALL_PREFIX}/lib/java/${java_name}.jar)
    get_directory_property(${java_name}Parent PARENT_DIRECTORY)
    if(NOT "${${java_name}Parent}" STREQUAL "")
      set(${java_name_upper}_JAVA_JAR ${${java_name_upper}_JAVA_JAR}
        PARENT_SCOPE)
      set(java_cp_jars "${java_cp_jars}" PARENT_SCOPE)
    endif()

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${java_name}.jar
      DESTINATION lib/java)
    install(TARGETS ${SWIG_MODULE_${java_name}Java_REAL_NAME}
      DESTINATION ${java_dest})
  endmacro()
endif()

include(GNUInstallDirs)

add_subdirectory(core)
include_directories(${XdmfCore_INCLUDE_DIRS} ${XdmfDSM_INCLUDE_DIRS})

option(XDMF_BUILD_CORE_ONLY OFF)
mark_as_advanced(XDMF_BUILD_CORE_ONLY)
if(NOT XDMF_BUILD_CORE_ONLY)
  set(XdmfSources
    XdmfAggregate
    XdmfAttribute
    XdmfAttributeCenter
    XdmfAttributeType
    XdmfCurvilinearGrid
    XdmfDomain
    XdmfGeometry
    XdmfGeometryType
    XdmfGraph
    XdmfGrid
    XdmfGridCollection
    XdmfGridCollectionType
    XdmfGridController
    XdmfGridTemplate
    XdmfItemFactory
    XdmfMap
    XdmfReader
    XdmfRectilinearGrid
    XdmfRegularGrid
    XdmfSet
    XdmfSetType
    XdmfTemplate
    XdmfTime
    XdmfTopology
    XdmfTopologyType
    XdmfUnstructuredGrid)

  add_library(${XDMF_LIBNAME} ${XdmfSources})
  SET_TARGET_PROPERTIES(
    ${XDMF_LIBNAME} PROPERTIES
    VERSION ${XDMF_VERSION}
    SOVERSION ${XDMF_MAJOR_VERSION}
    )
  if(XDMF_BUILD_DSM)
    target_link_libraries(${XDMF_LIBNAME} XdmfCore XdmfDSM)
  else(XDMF_BUILD_DSM)
    target_link_libraries(${XDMF_LIBNAME} XdmfCore)
  endif(XDMF_BUILD_DSM)

  if(WIN32)
    if (BUILD_SHARED_LIBS)
      set_target_properties(${XDMF_LIBNAME} PROPERTIES
        DEFINE_SYMBOL XDMF_EXPORTS)
    endif ()
  endif()

  if(XDMF_WRAP_JAVA)
    XDMF_SWIG_JAVA(${XDMF_LIBNAME} Compiled_XdmfCore_Jar)
  endif()

  if(XDMF_WRAP_PYTHON)
    if (NOT BUILD_SHARED_LIBS)
      message(FATAL_ERROR "Python Wrappers do not function"
                          " properly without shared libraries")
    endif (NOT BUILD_SHARED_LIBS)
    if (XDMF_BUILD_DSM)
      XDMF_SWIG_PYTHON(${XDMF_LIBNAME} XdmfCore XdmfDSM)
    else()
      XDMF_SWIG_PYTHON(${XDMF_LIBNAME} XdmfCore)
    endif()
    set(
      XDMF_PYTHON_INSTALL_DIR
      ${CMAKE_INSTALL_PREFIX}/lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/xdmf
      )
  endif()

  if(XDMF_BUILD_TESTING)
    add_subdirectory(tests)
  endif()

  option(XDMF_BUILD_UTILS OFF)
  if(XDMF_BUILD_UTILS)
    add_subdirectory(utils)
  endif()

  file(GLOB XdmfHeaders
    "*.hpp"
    "*.tpp"
    "*.i"
    "${CMAKE_CURRENT_BINARY_DIR}/*.hpp"
  )
  install(FILES ${XdmfHeaders} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
  install(TARGETS ${XDMF_LIBNAME}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR CMake)
else()
  set(DEF_INSTALL_CMAKE_DIR
    "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
endif()
xdmf_create_config_file(${PROJECT_NAME})
install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
  DESTINATION ${DEF_INSTALL_CMAKE_DIR})

=== core/CMakeLists.txt ===
project(XdmfCore)

include(CheckCXXSourceCompiles)
include(SetUpVersion)
include(TestBigEndian)

if(VERSION_CONTROL_AUTOUPDATE OR
    NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/XdmfVersion.hpp)
  VersionCreate(
    "Xdmf"
    "${XDMF_MAJOR_VERSION}" "${XDMF_MINOR_VERSION}" "${XDMF_PATCH_VERSION}"
    "XDMFCORE_EXPORT" "XdmfCore.hpp"
    )
endif()

if(BUILD_SHARED_LIBS)
  set(BUILD_SHARED 1)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(Boost REQUIRED)
if(Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
endif()

find_package(HDF5 REQUIRED)
if(HDF5_FOUND)
  include_directories(${HDF5_INCLUDE_DIRS})
  include_directories(${HDF5_C_INCLUDE_DIR})
  # FIXME: Would like to get this info from HDF5 so we don't have conflicting
  # MPI versions
  if(HDF5_IS_PARALLEL)
    if (NOT MPI_FOUND)
      find_package(MPI REQUIRED)
      if(MPI_FOUND)
        include_directories(${MPI_INCLUDE_PATH})
      endif()
    endif ()
  endif()
endif()


find_package(LibXml2 REQUIRED)
if(LIBXML2_FOUND)
  include_directories(${LIBXML2_INCLUDE_DIR})
endif()

# Perform compile-time checks and generate XdmfCoreConfig.hpp

TEST_BIG_ENDIAN(XDMF_BIG_ENDIAN)

set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${Boost_INCLUDE_DIRS})
check_cxx_source_compiles("
#include <boost/shared_ptr.hpp>

struct Base { virtual ~Base(){} };
struct Derived : public Base {};

int main(int ac, char * av[])
{
  boost::shared_ptr<Base> ptr(new Base());
  boost::shared_dynamic_cast<Derived>(ptr);
}
"
HAVE_BOOST_SHARED_DYNAMIC_CAST)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/XdmfCoreConfig.hpp.in
               ${CMAKE_CURRENT_BINARY_DIR}/XdmfCoreConfig.hpp)

set(XdmfCoreSources
  XdmfArray
  XdmfArrayReference
  XdmfArrayType
  XdmfBinaryController
  XdmfCoreItemFactory
  XdmfCoreReader
  XdmfError
  XdmfFunction
  XdmfHDF5Controller
  XdmfHDF5Writer
  XdmfHeavyDataController
  XdmfHeavyDataDescription
  XdmfHeavyDataWriter
  XdmfInformation
  XdmfItem
  XdmfItemProperty
  XdmfPlaceholder
  XdmfSparseMatrix
  XdmfSubset
  XdmfSystemUtils
  ${CMAKE_CURRENT_BINARY_DIR}/XdmfVersion
  XdmfVisitor
  XdmfWriter)

if (TIFF_FOUND)
  set(XdmfCoreSources
      ${XdmfCoreSources}
      XdmfTIFFController)
  set(FOUND_TIFF_LOCATION core/XdmfTIFFController)
else ()
  set(FOUND_TIFF_LOCATION "")
endif()

set(XdmfCoreSources
  core/XdmfArray
  core/XdmfArrayReference
  core/XdmfArrayType
  core/XdmfBinaryController
  core/XdmfCoreItemFactory
  core/XdmfCoreReader
  core/XdmfError
  core/XdmfFunction
  core/XdmfHDF5Controller
  core/XdmfHDF5Writer
  core/XdmfHeavyDataController
  core/XdmfHeavyDataDescription
  core/XdmfHeavyDataWriter
  core/XdmfInformation
  core/XdmfItem
  core/XdmfItemProperty
  core/XdmfPlaceholder
  core/XdmfSparseMatrix
  core/XdmfSubset
  core/XdmfSystemUtils
  ${FOUND_TIFF_LOCATION}
  ${CMAKE_CURRENT_BINARY_DIR}/XdmfVersion
  core/XdmfVisitor
  core/XdmfWriter
  PARENT_SCOPE)

add_library(XdmfCore ${XdmfCoreSources})
SET_TARGET_PROPERTIES(
  XdmfCore PROPERTIES
  VERSION ${XDMF_VERSION}
  SOVERSION ${XDMF_MAJOR_VERSION}
  )

target_link_libraries(XdmfCore
  PUBLIC
    ${HDF5_C_LIBRARIES}
    ${LIBXML2_LIBRARIES})
if (TIFF_FOUND)
  target_link_libraries(XdmfCore
    PRIVATE
      ${TIFF_LIBRARIES})
endif ()

if(WIN32)
  #add_definitions(-D_HDF5USEDLL_ -D_HDF5USEHLDLL_)
  if (BUILD_SHARED_LIBS)
    set_target_properties(XdmfCore PROPERTIES
      DEFINE_SYMBOL XdmfCore_EXPORTS)
  endif()
endif()

if(XDMF_WRAP_JAVA)
  XDMF_SWIG_JAVA(XdmfCore)
endif()

if(XDMF_WRAP_PYTHON)
  if (NOT BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Python Wrappers do not function"
                        " properly without shared libraries")
  endif (NOT BUILD_SHARED_LIBS)
  XDMF_SWIG_PYTHON(XdmfCore)
endif()

file(GLOB_RECURSE
  XdmfCoreHeaders
  "*.hpp" "*.tpp" "*.i"
  "../CMake/VersionSuite/*.hpp")
file(GLOB LokiHeaders loki/*.h)

set(XdmfCoreHeaders
      ${XdmfCoreHeaders}
      ${CMAKE_CURRENT_BINARY_DIR}/XdmfCoreConfig.hpp)
install(FILES ${XdmfCoreHeaders} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${LokiHeaders} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/loki)
install(TARGETS XdmfCore
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

if (Boost_FOUND)
  set(FOUND_BOOST_INCLUDES ${Boost_INCLUDE_DIRS})
else ()
  set(FOUND_BOOST_INCLUDES "")
endif ()
set(XdmfCore_INCLUDE_DIRS
  ${FOUND_BOOST_INCLUDES}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${HDF5_INCLUDE_DIR}
  ${LIBXML2_INCLUDE_DIR}
  ${PYTHON_INCLUDE_DIRS}
  CACHE INTERNAL "")

set(XDMF_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include PARENT_SCOPE)
set(XDMF_DIR ${CMAKE_INSTALL_PREFIX} PARENT_SCOPE)

if(XDMF_BUILD_DSM)
  add_subdirectory(dsm)
  set(XDMF_DSM_IS_CRAY "${XDMF_DSM_IS_CRAY}" PARENT_SCOPE)
endif(XDMF_BUILD_DSM)

if(XDMF_BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== doc/CMakeLists.txt ===
include(UseDoxygen)

=== tests/CMakeLists.txt ===
add_subdirectory(C)
add_subdirectory(Cxx)

if(XDMF_WRAP_PYTHON)
  add_subdirectory(Python)
endif(XDMF_WRAP_PYTHON)
if(XDMF_WRAP_JAVA)
  add_subdirectory(Java)
endif(XDMF_WRAP_JAVA)

=== utils/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

option(XDMF_BUILD_EXODUS_IO OFF)
option(XDMF_BUILD_PARTITIONER OFF)
option(XDMF_BUILD_FORTRAN OFF)


set(XdmfUtilsSources
  XdmfDiff
  XdmfGeometryConverter
  XdmfTopologyConverter
  XdmfUtils)
set(XdmfUtilsLinkLibraries Xdmf)

if(XDMF_BUILD_FORTRAN)
  set(XdmfUtilsSources ${XdmfUtilsSources} XdmfFortran)
  enable_language (Fortran)
  if (XDMF_BUILD_DSM)
    # gcc doesn't automatically link to the fortran mpi libraries
    STRING(REGEX MATCH "gfortran" IS_GFORTRAN "${CMAKE_Fortran_COMPILER}")
    if (NOT "${IS_GFORTRAN}" STREQUAL "")
      EXECUTE_PROCESS(
        COMMAND ${MPIEXEC} --version
        OUTPUT_VARIABLE MPI_TYPE_OUTPUT
        ERROR_VARIABLE MPI_TYPE_ERROR
      )
      if (NOT "${MPI_TYPE_ERROR}" STREQUAL "")
        STRING(REGEX MATCH "Open" IS_OPENMPI "${MPI_TYPE_ERROR}")
      elseif (NOT "${MPI_TYPE_OUTPUT}" STREQUAL "")
        STRING(REGEX MATCH "Open" IS_OPENMPI "${MPI_TYPE_OUTPUT}")
      endif ()
      IF (NOT "${IS_OPENMPI}" STREQUAL "")
        if (NOT "${MPI_TYPE_ERROR}" STREQUAL "")
          STRING(REGEX MATCH "[0-9]+[.][0-9]+[.][0-9]+" MPI_VERSION "${MPI_TYPE_ERROR}")
        elseif (NOT "${MPI_TYPE_OUTPUT}" STREQUAL "")
          STRING(REGEX MATCH "[0-9]+[.][0-9]+[.][0-9]+" MPI_VERSION "${MPI_TYPE_OUTPUT}")
        endif ()
        if (NOT "${MPI_VERSION}" STREQUAL "")
          STRING(REGEX MATCH "^[0-9]+" MPI_VERSION_MAJOR "${MPI_VERSION}")
          STRING(REGEX MATCH "[0-9]+[.][0-9]+$" MPI_VERSION_CUT "${MPI_VERSION}")
          STRING(REGEX MATCH "^[0-9]+" MPI_VERSION_MINOR "${MPI_VERSION_CUT}")
          if (("${MPI_VERSION_MAJOR}" EQUAL 1) OR ("${MPI_VERSION_MAJOR}" LESS 1))
            if ("${MPI_VERSION_MAJOR}" EQUAL 1)
              if ("${MPI_VERSION_MINOR}" LESS 8)
                # Minor version is less than 1.8
                set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -lmpi_f90")
              else ("${MPI_VERSION_MINOR}" LESS 8)
                # Version is 1.8.0 or greater
                set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -lmpi_mpifh")
              endif ("${MPI_VERSION_MINOR}" LESS 8)
            else ("${MPI_VERSION_MAJOR}" EQUAL 1)
              # Major version is less than 1
              set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -lmpi_f90")
            endif ("${MPI_VERSION_MAJOR}" EQUAL 1)
          else (("${MPI_VERSION_MAJOR}" EQUAL 1) OR ("${MPI_VERSION_MAJOR}" LESS 1))
            # Major version is greater than 1
            set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -lmpi_mpifh")
          endif (("${MPI_VERSION_MAJOR}" EQUAL 1) OR ("${MPI_VERSION_MAJOR}" LESS 1))
        endif (NOT "${MPI_VERSION}" STREQUAL "")
      ENDIF (NOT "${IS_OPENMPI}" STREQUAL "")
    endif (NOT "${IS_GFORTRAN}" STREQUAL "")
  endif (XDMF_BUILD_DSM)
endif(XDMF_BUILD_FORTRAN)

if (XDMF_BUILD_DSM)
  add_definitions(-DXDMF_BUILD_DSM)
endif (XDMF_BUILD_DSM)

if(XDMF_BUILD_EXODUS_IO)
  set(XDMF_SWIG_FLAGS ${XDMF_SWIG_FLAGS} -DXDMF_BUILD_EXODUS_IO)
  find_package(Exodus REQUIRED)
  if(EXODUS_FOUND)
    include_directories(${EXODUS_INCLUDE_DIR} ${NetCDF_INCLUDE_DIR})
  endif(EXODUS_FOUND)
  set(XdmfUtilsSources ${XdmfUtilsSources} XdmfExodusReader XdmfExodusWriter)
  set(XdmfUtilsExecutables ${XdmfUtilsExecutables} XdmfExodusConverter)
  set(XdmfUtilsLinkLibraries
    ${XdmfUtilsLinkLibraries}
    ${EXODUS_LIBRARIES}
    ${NetCDF_LIBRARIES})
endif(XDMF_BUILD_EXODUS_IO)

if(XDMF_BUILD_PARTITIONER)
  set(XDMF_SWIG_FLAGS ${XDMF_SWIG_FLAGS} -DXDMF_BUILD_PARTITIONER)
  find_package(Metis REQUIRED)
  if(METIS_FOUND)
    include_directories(${METIS_INCLUDE_DIR})
  endif(METIS_FOUND)
  set(XdmfUtilsExecutables ${XdmfUtilsExecutables} XdmfPartitioner)
  set(XdmfUtilsSources ${XdmfUtilsSources} XdmfPartitioner)
  set(XdmfUtilsLinkLibraries ${XdmfUtilsLinkLibraries} ${METIS_LIBRARIES})
endif(XDMF_BUILD_PARTITIONER)

add_library(XdmfUtils ${XdmfUtilsSources})
SET_TARGET_PROPERTIES(
  XdmfUtils PROPERTIES
  VERSION ${XDMF_VERSION}
  SOVERSION ${XDMF_MAJOR_VERSION}
  )

target_link_libraries(XdmfUtils ${XdmfUtilsLinkLibraries})

if(WIN32)
  set_target_properties(${executable} PROPERTIES
      DEFINE_SYMBOL XdmfUtils_EXPORTS)
endif(WIN32)

foreach(executable ${XdmfUtilsExecutables})
  add_executable(${executable} ${executable})
  set_target_properties(${executable} PROPERTIES COMPILE_FLAGS -DBUILD_EXE)
  target_link_libraries(${executable} XdmfUtils)

  if(WIN32)
	  set_target_properties(${executable} PROPERTIES
	      DEFINE_SYMBOL XdmfUtils_EXPORTS)
  endif(WIN32)

endforeach(executable ${XdmfUtilsExecutables})

if(XDMF_BUILD_TESTING)
  add_subdirectory(tests)
endif(XDMF_BUILD_TESTING)

if(XDMF_WRAP_JAVA)
  XDMF_SWIG_JAVA(XdmfUtils Compiled_Xdmf_Jar)
endif(XDMF_WRAP_JAVA)


if(XDMF_WRAP_PYTHON)
  if (NOT BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Python Wrappers do not function"
                        " properly without shared libraries")
  endif (NOT BUILD_SHARED_LIBS)
  XDMF_SWIG_PYTHON(XdmfUtils Xdmf)
endif(XDMF_WRAP_PYTHON)

foreach(source ${XdmfUtilsSources})
  set(XdmfUtilsHeaders ${XdmfUtilsHeaders} ${source}.hpp)
endforeach(source ${XdmfUtilsSources})

if(XDMF_BUILD_FORTRAN)
  set(XdmfUtilsHeaders ${XdmfUtilsHeaders} Xdmf.f)
endif(XDMF_BUILD_FORTRAN)

install(FILES ${XdmfUtilsHeaders} DESTINATION include)
install(TARGETS XdmfUtils
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS ${XdmfUtilsExecutables}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== core/dsm/CMakeLists.txt ===
project(XdmfDSM)

set(XdmfDSMLinkLibraries XdmfCore)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include_directories(${Boost_INCLUDE_DIRS})

set(XdmfDSMSources
  XdmfHDF5ControllerDSM
  XdmfHDF5WriterDSM
  XdmfDSMCommMPI
  XdmfDSMBuffer
  XdmfDSMDescription
  XdmfDSMItemFactory
  XdmfDSMDriver)

if (XDMF_BUILD_DSM_THREADS)
  add_definitions(-DXDMF_BUILD_DSM_THREADS)
endif ()

if (XDMF_BUILD_DSM_THREADS)
  find_package(H5FDdsm REQUIRED NO_MODULE)
  if(H5FDdsm_FOUND)
    include_directories(${H5FDdsm_INCLUDE_DIR})
    get_property(h5fddsm_lib_location TARGET H5FDdsm PROPERTY LOCATION)
    set(H5FDdsm_LIBRARIES ${h5fddsm_lib_location})
    set(XdmfDSMLinkLibraries ${XdmfDSMLinkLibraries} ${H5FDdsm_LIBRARIES})
  else()
    message(SEND_ERROR
      "Cannot find HDF5 DSM!  Please set H5FDdsm_DIR or disable XDMF_BUILD_DSM_THREADS and configure again.")
  endif()
endif ()

# Set a variable if cray is being used
STRING(REGEX MATCH "aprun" IS_CRAY "${MPIEXEC}")

set(XDMF_DSM_IS_CRAY "${IS_CRAY}")
set(XDMF_DSM_IS_CRAY "${XDMF_DSM_IS_CRAY}" PARENT_SCOPE)

if (XDMF_DSM_IS_CRAY)
  add_definitions(-DXDMF_DSM_IS_CRAY)
endif (XDMF_DSM_IS_CRAY)

add_library(XdmfDSM ${XdmfDSMSources})
SET_TARGET_PROPERTIES(
  XdmfDSM PROPERTIES
  VERSION ${XDMF_VERSION}
  SOVERSION ${XDMF_MAJOR_VERSION}
  )
target_link_libraries(XdmfDSM ${XdmfDSMLinkLibraries})

if(WIN32)
  add_definitions(-D_HDF5USEDLL_ -D_HDF5USEHLDLL_)
  set_target_properties(XdmfDSM PROPERTIES
      DEFINE_SYMBOL XdmfDSM_EXPORTS)
endif()

if(XDMF_WRAP_JAVA)
  XDMF_SWIG_JAVA(XdmfDSM Compiled_XdmfCore_Jar)
endif()

if(XDMF_WRAP_PYTHON)
  if (NOT BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Python Wrappers do not function"
                        " properly without shared libraries")
  endif (NOT BUILD_SHARED_LIBS)
  XDMF_SWIG_PYTHON(XdmfDSM XdmfCore)
endif()


file(GLOB_RECURSE
  XdmfDSMHeaders
  "*.hpp" "*.tpp" "*.i"
  "../../CMake/VersionSuite/*.hpp")
install(FILES ${XdmfDSMHeaders} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(TARGETS XdmfDSM
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(XDMF_BUILD_DSM_THREADS)
set(XdmfDSM_INCLUDE_DIRS
  ${Boost_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${HDF5_INCLUDE_DIR}
  ${H5FDdsm_INCLUDE_DIR}
  ${LIBXML2_INCLUDE_DIR}
  ${PYTHON_INCLUDE_DIRS}
  CACHE INTERNAL "")
else()
set(XdmfDSM_INCLUDE_DIRS
  ${Boost_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${HDF5_INCLUDE_DIR}
  ${LIBXML2_INCLUDE_DIR}
  ${PYTHON_INCLUDE_DIRS}
  CACHE INTERNAL "")
endif()

include_directories(${XdmfCore_INCLUDE_DIRS} ${XdmfDSM_INCLUDE_DIRS})

if(XDMF_BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== core/tests/CMakeLists.txt ===
add_subdirectory(C)
add_subdirectory(Cxx)

if(XDMF_WRAP_PYTHON)
  add_subdirectory(Python)
endif(XDMF_WRAP_PYTHON)

if(XDMF_WRAP_JAVA)
  add_subdirectory(Java)
endif(XDMF_WRAP_JAVA)

=== tests/C/CMakeLists.txt ===
# Include our test macros
include(AddTestsC)

# Add any dependencies that the cxx core tests may need
# Note: The tests already depend on their own file
ADD_TEST_C_DEPENDENCIES("Xdmf")

# Add any ldpath directories that the cxx tests may need
ADD_TEST_C_LDPATH("${CMAKE_BINARY_DIR}")

# Add any path directoreis that the Cxx tests may need
ADD_TEST_C_PATH("${CMAKE_BINARY_DIR}")

# Add any cxx tests here:
# Note: We don't want to use a foreach loop to test the files incase we
#       have extra arguments (ie: ADD_TEST_C(testname inputfile))
#       Read UseCxxTest.cmake for more information
# ---------------------------------------
ADD_TEST_C(CTestXdmfWriter)
ADD_TEST_C(CTestXdmfAggregate)
ADD_TEST_C(CTestXdmfAttribute)
ADD_TEST_C(CTestXdmfBinaryController)
ADD_TEST_C(CTestXdmfDomain)
if (TIFF_FOUND)
  ADD_TEST_C(CTestXdmfTIFFReadWriteCompressed)
endif ()
ADD_TEST_C(CTestXdmfTopology)
ADD_TEST_C(CTestXdmfGeometry)
ADD_TEST_C(CTestXdmfGraph)
ADD_TEST_C(CTestXdmfGridCollection)
ADD_TEST_C(CTestXdmfGridController)
ADD_TEST_C(CTestXdmfCurvilinearGrid)
ADD_TEST_C(CTestXdmfRectilinearGrid)
ADD_TEST_C(CTestXdmfRegularGrid)
ADD_TEST_C(CTestXdmfUnstructuredGrid)
ADD_TEST_C(CTestXdmfMap)
ADD_TEST_C(CTestXdmfSet)

# Add any cxx cleanup here:
# Note: We don't want to use a foreach loop to test the files incase we
#       have multiple files (ie: CLEAN_TEST_C(testname outputfile1 ...))
#       Read UseCxxTest.cmake for more information
# ---------------------------------------
CLEAN_TEST_C(CTestXdmfWriter
  testfile.xmf
  testfile.h5
  secondtestfile.xmf
  secondtestfile.h5
  subsetfile.xmf
  subsetfile.h5
  functionfile.xmf
  functionfile.h5)
CLEAN_TEST_C(CTestXdmfAggregate,
  aggregate.xmf
  aggregate.h5)
CLEAN_TEST_C(CTestXdmfAttribute
  attributefile.xmf
  attributefile.h5)
CLEAN_TEST_C(CTestXdmfBinaryController
  binary.bin)
CLEAN_TEST_C(CTestXdmfDomain
  domainfile.xmf
  domainfile.h5)
if (TIFF_FOUND)
  CLEAN_TEST_C(CTestXdmfTIFFReadWriteCompressed
    compressedstripoutput.tif)
endif ()
CLEAN_TEST_C(CTestXdmfTopology
  topofile.xmf
  topofile.h5)
CLEAN_TEST_C(CTestXdmfGeometry
  geofile.xmf
  geofile.h5)
CLEAN_TEST_C(CTestXdmfGraph
  matrixfile.xmf
  matrixfile.h5)
CLEAN_TEST_C(CTestXdmfGridCollection
  colfile.xmf
  colfile.h5)
CLEAN_TEST_C(CTestXdmfGridController
  gridControllerReference.xmf
  gridController.xmf)
CLEAN_TEST_C(CTestXdmfCurvilinearGrid
  curvfile.xmf
  curvfile.h5)
CLEAN_TEST_C(CTestXdmfRectilinearGrid
  rectfile.xmf
  rectfile.h5)
CLEAN_TEST_C(CTestXdmfRegularGrid
  regfile.xmf
  regfile.h5)
CLEAN_TEST_C(CTestXdmfUnstructuredGrid
  unfile.xmf
  unfile.h5)
CLEAN_TEST_C(CTestXdmfMap
  mapfile.xmf
  mapfile.h5)
CLEAN_TEST_C(CTestXdmfSet
  setfile.xmf
  setfile.h5)

=== tests/Cxx/CMakeLists.txt ===
# Include our test macros
include(AddTestsCxx)

# Add any dependencies that the cxx tests may need
# Note: The tests already depend on their own file
ADD_TEST_CXX_DEPENDENCIES("Xdmf")

# Add any cxx tests here:
# Note: We don't want to use a foreach loop to test the files incase we
#	have extra arguments (id: ADD_TEST_CXX(testname inputfile))
#	Read UseCxxTest.cmake for more information
# ---------------------------------------
if ("${XDMF_DSM_IS_CRAY}" STREQUAL "")
  IF (MPIEXEC_MAX_NUMPROCS GREATER 5)
    ADD_MPI_TEST_CXX(DSMFileTest.sh XdmfFileAcceptTest,XdmfFileConnectTest)
  ENDIF(MPIEXEC_MAX_NUMPROCS GREATER 5)
endif ("${XDMF_DSM_IS_CRAY}" STREQUAL "")
ADD_TEST_CXX(TestXdmfAggregate)
ADD_TEST_CXX(TestXdmfAttribute)
ADD_TEST_CXX(TestXdmfBinaryController)
ADD_TEST_CXX(TestXdmfCurvilinearGrid)
ADD_TEST_CXX(TestXdmfFunction)
ADD_TEST_CXX(TestXdmfGeometry)
ADD_TEST_CXX(TestXdmfGraph)
ADD_TEST_CXX(TestXdmfGridCollection)
ADD_TEST_CXX(TestXdmfGridController)
ADD_TEST_CXX(TestXdmfGridTemplate)
ADD_TEST_CXX(TestXdmfHDF5Hyperslab)
ADD_TEST_CXX(TestXdmfHDF5Visit)
ADD_TEST_CXX(TestXdmfMap)
ADD_TEST_CXX(TestXdmfMultiOpen)
ADD_TEST_CXX(TestXdmfMultiXPath)
ADD_TEST_CXX(TestXdmfReader)
ADD_TEST_CXX(TestXdmfRegularGrid)
ADD_TEST_CXX(TestXdmfRectilinearGrid)
ADD_TEST_CXX(XdmfPostFixCalc)
ADD_TEST_CXX(TestXdmfSet)
ADD_TEST_CXX(TestXdmfSubset)
ADD_TEST_CXX(TestXdmfTemplate)
ADD_TEST_CXX(TestXdmfTime)
if (TIFF_FOUND)
  ADD_TEST_CXX(TestXdmfTIFFReadWriteCompressed)
endif (TIFF_FOUND)
ADD_TEST_CXX(TestXdmfTopology)
ADD_TEST_CXX(TestXdmfTopologyMixed)
ADD_TEST_CXX(TestXdmfUnstructuredGrid)
ADD_TEST_CXX(TestXdmfVisitorValueCounter)
ADD_TEST_CXX(TestXdmfWriter)
ADD_TEST_CXX(TestXdmfWriterHDF5ThenXML)
ADD_TEST_CXX(TestXdmfXPath)
ADD_TEST_CXX(TestXdmfXPointerReference)
#removed due to long execution time
#ADD_TEST_CXX(HugeWriteArray)

# Add any cxx cleanup here:
# Note: We don't want to use a foreach loop to test the files incase we
#       have multiple files (ie: CLEAN_TEST_CXX(testname outputfile1 ...))
#       Read UseCxxTest.cmake for more information
# ---------------------------------------
if ("${XDMF_DSM_IS_CRAY}" STREQUAL "")
  IF (MPIEXEC_MAX_NUMPROCS STRGREATER 5)
    CLEAN_TEST_CXX(DSMFileTest.sh dsmfile.xmf dsmconnect.cfg)
  ENDIF (MPIEXEC_MAX_NUMPROCS STRGREATER 5)
endif ("${XDMF_DSM_IS_CRAY}" STREQUAL "")
CLEAN_TEST_CXX(TestXdmfAggregate
  aggregate.xmf
  aggregate.h5)
CLEAN_TEST_CXX(TestXdmfAttribute)
CLEAN_TEST_CXX(TestXdmfBinaryController
  TestXdmfBinary.xmf
  testBinary.bin)
CLEAN_TEST_CXX(TestXdmfCurvilinearGrid
  TestXdmfCurvilinearGrid1.xmf
  TestXdmfCurvilinearGrid2.xmf)
CLEAN_TEST_CXX(TestXdmfFunction
  function.xmf
  function.h5)
CLEAN_TEST_CXX(TestXdmfGeometry)
CLEAN_TEST_CXX(TestXdmfGraph
  TestXdmfGraph.xmf)
CLEAN_TEST_CXX(TestXdmfGridCollection
  TestXdmfGridCollection1.xmf
  TestXdmfGridCollection2.xmf
  TestXdmfGridCollectionHDF1.h5
  TestXdmfGridCollectionHDF1.xmf
  TestXdmfGridCollectionHDF2.xmf)
CLEAN_TEST_CXX(TestXdmfGridTemplate
  gridtemplate.xmf
  gridtemplate.h5
  gridtemplate2.xmf
  gridtemplate2.h5)
CLEAN_TEST_CXX(TestXdmfHDF5Hyperslab
  TestXdmfHDF5Hyperslab.xmf
  TestXdmfHDF5Hyperslab.h5
  TestXdmfHDF5Hyperslab2.xmf)
CLEAN_TEST_CXX(TestXdmfHDF5Visit
  TestXdmfHDF5Visit.xmf
  TestXdmfHDF5Visit.h5)
CLEAN_TEST_CXX(TestXdmfMap
  TestXdmfMap1.xmf
  TestXdmfMap2.xmf
  TestXdmfMapHDF1.xmf
  TestXdmfMapHDF1.h5
  TestXdmfMapHDF2.xmf)
CLEAN_TEST_CXX(TestXdmfMultiOpen
  setfile.h5
  attributefile.h5)
CLEAN_TEST_CXX(TestXdmfMultiXPath
  nestedOuter.xmf
  nestedInner.xmf)
CLEAN_TEST_CXX(TestXdmfReader
  TestXdmfReader1.h5
  TestXdmfReader1.xmf
  TestXdmfReader2.xmf)
CLEAN_TEST_CXX(TestXdmfRectilinearGrid
  TestXdmfRectilinearGrid1.xmf
  TestXdmfRectilinearGrid2.xmf)
CLEAN_TEST_CXX(TestXdmfRegularGrid
  TestXdmfRegularGrid1.xmf
  TestXdmfRegularGrid2.xmf)
CLEAN_TEST_CXX(XdmfPostFixCalc)
CLEAN_TEST_CXX(TestXdmfSet)
CLEAN_TEST_CXX(TestXdmfSubset
  subset.xmf
  subset.h5)
CLEAN_TEST_CXX(TestXdmfTemplate
  template.xmf
  template.h5
  template2.xmf
  template2.h5)
CLEAN_TEST_CXX(TestXdmfTime)
if (TIFF_FOUND)
  CLEAN_TEST_CXX(TestXdmfTIFFReadWriteCompressed
    compressedtiffoutput.xmf
    compressedoutput.tif
    compressedstripoutput.tif
    compresseddirectories.tif)
endif (TIFF_FOUND)
CLEAN_TEST_CXX(TestXdmfTopology)
CLEAN_TEST_CXX(TestXdmfTopologyMixed
  TestXdmfTopologyMixed1.xmf
  TestXdmfTopologyMixed2.xmf)
CLEAN_TEST_CXX(TestXdmfUnstructuredGrid)
CLEAN_TEST_CXX(TestXdmfVisitorValueCounter)
CLEAN_TEST_CXX(TestXdmfWriter
  output.h5
  output.xmf)
CLEAN_TEST_CXX(TestXdmfWriterHDF5ThenXML)
CLEAN_TEST_CXX(TestXdmfXPath
  XdmfXPath1.xmf
  XdmfXPath2.xmf)
CLEAN_TEST_CXX(TestXdmfXPointerReference
  duplicateXpointer.xmf
  duplicateXpointer.h5
  duplicateXpointer2.xmf
  duplicateXpointer2.h5)
#removed due to long execution time
#CLEAN_TEST_CXX(HugeWriteArray
#  arraydata1.h5
#  arraydata2.h5
#  arraydata3.h5
#  arraydata.h5
#  arraydata.xmf)

=== tests/Java/CMakeLists.txt ===
INCLUDE(AddTestsJava)

# Add any dependencies that the java tests may need
# Note: The tests already depend on their own file
#	JAVA_TEST_DEPENDENCIES is also set in core
ADD_TEST_JAVA_DEPENDENCIES(Compiled_Xdmf_Jar)

# Add any classpath directories that the java tests may need
# Note: JAVA_TEST_CLASSPATH is also set in core
ADD_TEST_JAVA_CLASSPATH("${Xdmf_JAVA_JAR}")

# Add any ldpath directories that the java tests may need
# Note: JAVA_TEST_LDPATH is also set in core
ADD_TEST_JAVA_LDPATH("")

# Add any java tests here:
# Note:	We don't want to use a foreach loop to test the files incase we
#	have extra arguments (ie: ADD_TEST_JAVA(testname inputfile))
#	Read UseJavaTest.cmake for more information
# ------------------------
ADD_TEST_JAVA(TestXdmfJava)
ADD_TEST_JAVA(TestXdmfEquals)
ADD_TEST_JAVA(TestXdmfGC)

# Add any java cleanup here:
# Note: We don't want to use a foreach loop to test the files incase we
#	have multiple files (ie: CLEAN_TEST_JAVA(testname outputfile1 ...))
#	Read UseCxxTest.cmake for more information
# ---------------------------------------
CLEAN_TEST_JAVA(TestXdmfJava
	outputJavaTest.xmf
)
CLEAN_TEST_JAVA(TestXdmfEquals)
CLEAN_TEST_JAVA(TestXdmfGC outputXdmfGC.xmf)

# Add a custom target for all java tests 
# Note: ${TARGETS} is set in ADD_TEST_JAVA
#IF(EXISTS Java_Core_Test_target)
#	SET(Java_Core_Test_target Java_Core_Test_target)
#ENDIF(EXISTS Java_Core_Test_target)

#GET_PROPERTY(targets GLOBAL PROPERTY JAVA_TEST_TARGETS)
#ADD_CUSTOM_TARGET(Java_ALLTEST ALL DEPENDS ${Java_Core_Test_target} XdmfJava ${targets}) 
CREATE_TARGET_TEST_JAVA()

=== tests/Python/CMakeLists.txt ===
include(AddTestsPython)

# Add any dependencies that the python tests may need
# Note: The tests already depend on their own file
#	PYTHON_TEST_DEPENDENCIES is also set in core
ADD_TEST_PYTHON_DEPENDENCIES("")

# Add any pythonpath directories that the python tests may need
# Note: PYTHON_TEST_PYTHONPATH is also set in core
ADD_TEST_PYTHON_PYTHONPATH("${PYTHON_INCLUDE_MPI4PY_DIR}/../..")

# Add any python tests here:
# Note: We don't want to use a foreach loop to test the files incase we
#	have extra arguments (ie: ADD_TEST_PYTHON(testname inputfile))
#	Read UsePythonTest.cmake for more information
# -----------------------
ADD_TEST_PYTHON(TestXdmfEquals)
ADD_TEST_PYTHON(TestXdmfFunction)
ADD_TEST_PYTHON(TestXdmfFunctionRead)
ADD_TEST_PYTHON(TestXdmfHDF5Writer)
ADD_TEST_PYTHON(TestXdmfRead)
ADD_TEST_PYTHON(TestXdmfSet)
ADD_TEST_PYTHON(TestXdmfWriter)
ADD_TEST_PYTHON(TestXdmfXPointerReference)
ADD_TEST_PYTHON(ReadTypeTest)


# Add any python cleanup here:
# Note: We don't want to use a foreach loop to test the files incase we
#	have multiple files (ie: CLEAN_TEST_PYTHON(testname outputfile1 ...))
#	Read UseCxxTest.cmake for more information
# ---------------------------------------
CLEAN_TEST_PYTHON(TestXdmfEquals)
CLEAN_TEST_PYTHON(TestXdmfFunction
  function.xmf
  function.h5)
CLEAN_TEST_PYTHON(TestXdmfFunctionRead)
CLEAN_TEST_PYTHON(TestXdmfHDF5Writer
  hdf5WriterPythonTest.h5)
CLEAN_TEST_PYTHON(TestXdmfRead
  TestXdmfRead.xmf
  TestXdmfRead.h5)
CLEAN_TEST_PYTHON(TestXdmfSet)
CLEAN_TEST_PYTHON(TestXdmfWriter
  output.h5
  output.xmf)
CLEAN_TEST_PYTHON(TestXdmfXPointerReference
  duplicateXpointer.xmf
  duplicateXpointer.h5
  duplicateXpointer2.xmf
  duplicateXpointer2.h5)
CLEAN_TEST_PYTHON(ReadTypeTest
  typeTest.h5
  typeTest.xmf)


# Add a custom target for all python tests
# Note: ${TARGETS} is set in ADD_TEST_PYTHON
#IF(EXISTS Python_Core_Test_target)
#	SET(Python_Core_Test_target Python_Core_Test_target)
#ENDIF(EXISTS Python_Core_Test_target)

#GET_PROPERTY(targets GLOBAL PROPERTY PYTHON_TEST_TARGETS)
#ADD_CUSTOM_TARGET(Python_ALLTEST ALL DEPENDS ${Python_Core_Test_target} ${targets})
CREATE_TARGET_TEST_PYTHON()

=== core/dsm/tests/CMakeLists.txt ===
add_subdirectory(C)
add_subdirectory(Cxx)

if(XDMF_WRAP_PYTHON)
  add_subdirectory(Python)
endif(XDMF_WRAP_PYTHON)

=== debian/control ===
Source: xdmf
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12),
  dh-sequence-python3, 
  python3-all-dev, 
  cmake(>= 2.4.0), 
  libhdf5-serial-dev, libhdf5-mpi-dev,
  libxml2-dev,  libboost-dev,
  libtiff-dev,
  gfortran | fortran-compiler, 
  swig, 
  bzip2, libbz2-dev,
  libgzstream-dev,
  libmetis-dev
Build-Conflicts: libxdmf-dev
Standards-Version: 4.5.0
Homepage: http://www.xdmf.org/
Vcs-Browser: https://salsa.debian.org/science-team/xdmf
Vcs-Git: https://salsa.debian.org/science-team/xdmf.git

Package:  libxdmf3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: eXtensible Data Model and Format library
 The need for a standardized method to exchange scientific data between 
 High Performance Computing codes and tools lead to the development of the 
 eXtensible Data Model and Format (XDMF) . Uses for XDMF range from a 
 standard format used by HPC codes to take advantage of widely used 
 visualization programs like ParaView and VisIt, 
 to a mechanism for performing coupled calculations using multiple, 
 previously stand alone codes.
 .
 XDMF uses XML to store Light data and to describe the data Model. 
 HDF5 is used to store Heavy data. The data Format is stored redundantly
 in both XML and HDF5. This allows tools to parse XML to determine the 
 resources that will be required to access the Heavy data. 
 .
 This package provides a version built on the serial version of HDF5.

Package: libxdmf-dev
Section: libdevel
Architecture: any
Conflicts: libloki-dev
Depends: libxdmf3  (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libgzstream-dev
Breaks: libxdmf3 (<< 3.0+git20190531)
Description: eXtensible Data Model and Format development tools
 This package contains the headers and development tools needed to build
 against the Xdmf libraries.

Package: python3-xdmf
Section: python
Architecture: any
Depends: libxdmf3  (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python3 wrappers for the eXtensible Data Model and Format library
 This package provides python3 wrappers for the libXDMF library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1


# The magic debhelper rule:
%:
	dh $@ --buildsystem cmake 

include /usr/share/mpi-default-dev/debian_defaults
MPI:=$(ARCH_DEFAULT_MPI_IMPL)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TMPDIR=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/${DEB_HOST_MULTIARCH}
PY3DEST:=debian/python3-xdmf
PY3:=$(shell py3versions -d)
PY3SUPPORTED:=$(shell py3versions -s)

CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) -fPIC

AUTOGENERATED:= python3-xdmf.install libxdmf-dev.install libxdmf3.install \
		libxdmf3.links libxdmf-dev.links

build_types:= mpi serial
BUILD_DIRS := $(foreach B,$(build_types),$(foreach P,$(PY3SUPPORTED),debian/build-$B-$P))

CMAKE_FLAGS:= -DXDMF_SYSTEM_ZLIB=ON \
		-DXDMF_SYSTEM_LIBXML2=ON \
		-DXDMF_USE_BZIP2=ON \
		-DXDMF_USE_GZIP=ON \
		-DXDMF_BUILD_FORTRAN=ON  \
		-DXDMF_SWIG_FLAGS=-py3 \
		-DXDMF_SYSTEM_HDF5=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DXDMF_BUILD_UTILS=ON \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DXDMF_WRAP_PYTHON=ON \
		-DXDMF_REGENERATE_WRAPPERS=ON \
		-DGZSTREAM_LIBRARY=$(LIBDIR)/libgzstream.so \
		-DBUILD_SHARED_LIBS=TRUE 

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		cat debian/$$f.in |  \
		sed -e 's%@PY3@%${PY3}%g' | \
		sed -e 's%@MPI@%${MPI}%g' | \
		sed -e 's%@MULTIARCH@%${DEB_HOST_MULTIARCH}%g'  \
		> debian/$$f ; \
		done
	mkdir -p $(BUILD_DIRS)
	for p in $(PY3SUPPORTED) ; do \
		l=`echo $$p | sed -e 's/python3.7/python3.7m/' ` ; \
		(cd debian/build-serial-$$p &&  \
			cmake ../.. \
				$(CMAKE_FLAGS) \
		                -DPYTHON_INCLUDE_PATH=/usr/include/$$p \
                		-DPYTHON_LIBRARY=$(LIBDIR)/lib$$l.so \
				-DXDMF_BUILD_MPI=OFF -DXDMF_SYSTEM_HDF5_IS_PARALLEL=OFF \
				-DHDF5_ROOT=$(LIBDIR)/hdf5/serial ) ; \
		(cd debian/build-mpi-$$p && \
			cmake ../.. \
				$(CMAKE_FLAGS) \
		               -DPYTHON_INCLUDE_PATH=/usr/include/$$p \
               			-DPYTHON_LIBRARY=$(LIBDIR)/lib$$l.so \
				-DXDMF_BUILD_MPI=ON  -DXDMF_SYSTEM_HDF5_IS_PARALLEL=ON \
				-DHDF5_ROOT=$(LIBDIR)/hdf5/$(MPI) ) ; \
		done

override_dh_auto_build:
	for p in $(BUILD_DIRS) ; do \
		$(MAKE) -C $$p ; done

override_dh_auto_test:
	@echo "Ignore; no tests present"

override_dh_auto_install:
	# Move needed for some reason
	for p in $(BUILD_DIRS) ; do \
		mkdir -p $$p/lib ; \
		cp $$p/*.py $$p/lib ; \
		done
	# Assemble something workable from the 4 install dirs.
	for p in $(PY3SUPPORTED) ; do \
		$(MAKE) -C debian/build-mpi-$$p install DESTDIR=$(TMPDIR) ; \
		mkdir -p 				$(PY3DEST)/usr/lib/$$p/dist-packages/xdmf/NoMpi ; \
		touch 				$(PY3DEST)/usr/lib/$$p/dist-packages/xdmf/__init__.py ; \
		cp debian/build-serial-$$p/Xdmf.py  	$(PY3DEST)/usr/lib/$$p/dist-packages/xdmf ; \
		cp debian/build-serial-$$p/XdmfUtils.py $(PY3DEST)/usr/lib/$$p/dist-packages/xdmf ; \
		cp debian/build-serial-$$p/XdmfCore.py  $(PY3DEST)/usr/lib/$$p/dist-packages/xdmf ; \
		cp debian/build-serial-$$p/lib/__*.so   $(PY3DEST)/usr/lib/$$p/dist-packages/xdmf/NoMpi ; \
		cp debian/build-mpi-$$p/lib/__*.so   $(PY3DEST)/usr/lib/$$p/dist-packages/xdmf ; \
		done

override_dh_auto_fixperms:
	dh_auto_fixperms
	find debian/libxdmf-dev -type f -exec chmod 644 {} \;

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -rf $(BUILD_DIRS)
